/**
	Generated by sails-inverse-model
	Date:Sun Oct 07 2018 11:23:29 GMT+1300 (NZDT)
*/

module.exports = {
    attributes: {
        inventarios_id: {
            model: "inventarios"
        },
        productos_epcs_id: {
            model: "epcs",
            unique:true
        },
        zonas_id: {
          model: 'zonas',
          required: true
        },

      //Relaciones muchos a muchos
      productos_zona_id: {
        model: "productosZona",
      },
    },
  /**
   * Antes de ingresar un producto a un inventario, debo validar:
   * Que el producto exista.
   * Que la zona del producto concuerde con la zona del inventario.
   * Que el estado del epc sea valido (1, lo que significa que se asigno y no se ha usado
   * @param valuesToSet
   * @param proceed
   */
  beforeCreate: function (valuesToSet, proceed) {

      ProductosZona.find({
        id: valuesToSet.productos_zona_id
      })
        .populate('epcs_id')
        .then(function (productoZona) {
          //Si el producto existe
          if (productoZona && productoZona.length > 0) {
            //Si la zona del proucto es la misma a la que se le va a asignar
            if (productoZona[0].zonas_id == valuesToSet.zonas_id) {
              //Si el epc del producto esta habilitado
              if (productoZona[0].epcs_id.state == 1) {
                return proceed();
              } else {
                var err = new Error();
                err.bd = true;
                err.propio = true;
                err.number = 'error_IP03';
                return proceed(err);
              }
            } else {
              var err = new Error();
              err.bd = true;
              err.propio = true;
              err.number = 'error_IP02';
              return proceed(err);
            }
          } else{

            var err = new Error();
            err.bd = true;
            err.propio = true;
            err.number = 'error_IP01';
            return proceed(err);
          }
        }).catch(function (err) {
        err.bd = false;
        err.propio = false;
        err.number = 'error_IP03';
        return proceed(err);
      });

  },
  tableName: 'inventarios_productos'
};
